function err = prediction_error(Ytest,Ylearned,err_type)
%Computes regression or classification error.
% 
%   [PRED] = PREDICTION_ERROR(YTEST,YLEARNED,ERR_TYPE) if ERR_TYPE='regr' 
%       compute mean squared errror for test set XTEST. If ERR_TYPE='class'
%       computes classification error. 

if isequal(err_type,'regr');
    %computes the mean squared error 
    err = norm(Ylearned-(Ytest))^2/length(Ytest);
else
    %computes the classification error 
    
    err=sum(sign(Ytest.* Ylearned)<0)/double(length(Ytest));
    
end
